from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, String

Smcounter2_V0_1_0 = CommandToolBuilder(tool="smCounter2", base_command=["smCounter2"], inputs=[ToolInput(tag="in_run_path", input_type=File(optional=True), prefix="--runPath", doc=InputDocumentation(doc="path to working directory")), ToolInput(tag="in_bed_target", input_type=File(optional=True), prefix="--bedTarget", doc=InputDocumentation(doc="BED file")), ToolInput(tag="in_bam_file", input_type=File(optional=True), prefix="--bamFile", doc=InputDocumentation(doc="BAM file")), ToolInput(tag="in_out_prefix", input_type=File(optional=True), prefix="--outPrefix", doc=InputDocumentation(doc="file name prefix")), ToolInput(tag="in_n_cpu", input_type=Int(optional=True), prefix="--nCPU", doc=InputDocumentation(doc="number of CPU to use in parallel")), ToolInput(tag="in_min_bq", input_type=Int(optional=True), prefix="--minBQ", doc=InputDocumentation(doc="minimum base quality allowed for analysis")), ToolInput(tag="in_min_mq", input_type=Int(optional=True), prefix="--minMQ", doc=InputDocumentation(doc="minimum mapping quality allowed for analysis. If the\nbam is tagged with its mate's mapq, then the minimum\nof the R1 and R2 mapq will be used for comparison, if\nnot each read is compared independently.")), ToolInput(tag="in_hp_len", input_type=Int(optional=True), prefix="--hpLen", doc=InputDocumentation(doc="minimum length for homopolymers")), ToolInput(tag="in_mismatch_thr", input_type=Int(optional=True), prefix="--mismatchThr", doc=InputDocumentation(doc="average number of mismatches per 100 bases allowed")), ToolInput(tag="in_primer_dist", input_type=String(optional=True), prefix="--primerDist", doc=InputDocumentation(doc="filter variants that are within X bases to primer")), ToolInput(tag="in_mt_threshold", input_type=String(optional=True), prefix="--mtThreshold", doc=InputDocumentation(doc="threshold on read proportion to determine MT level\nconsensus")), ToolInput(tag="in_rpb", input_type=Int(optional=True), prefix="--rpb", doc=InputDocumentation(doc="mean read pairs per UMI; default at 0 and will be")), ToolInput(tag="in_primer_side", input_type=Int(optional=True), prefix="--primerSide", doc=InputDocumentation(doc="read end that includes the primer; default is 1")), ToolInput(tag="in_minal_tumi", input_type=Int(optional=True), prefix="--minAltUMI", doc=InputDocumentation(doc="minimum requirement of ALT UMIs; default is 3")), ToolInput(tag="in_maxalt_allele", input_type=Int(optional=True), prefix="--maxAltAllele", doc=InputDocumentation(doc="maximum ALT alleles that meet minAltUMI to be\nreported; default is 2 (tri-allelic variants)")), ToolInput(tag="in_ref_genome", input_type=File(optional=True), prefix="--refGenome", doc=InputDocumentation(doc="Path to the reference fasta file")), ToolInput(tag="in_rep_bed", input_type=File(optional=True), prefix="--repBed", doc=InputDocumentation(doc="Path to the simpleRepeat bed file")), ToolInput(tag="in_sr_bed", input_type=File(optional=True), prefix="--srBed", doc=InputDocumentation(doc="Path to the full repeat bed file")), ToolInput(tag="in_ds", input_type=Int(optional=True), prefix="--ds", doc=InputDocumentation(doc="down sample if number of UMIs greater than this value\n(RNA only)")), ToolInput(tag="in_bam_type", input_type=File(optional=True), prefix="--bamType", doc=InputDocumentation(doc="raw (default): raw BAM file with UMIs; consensus:\nconsensused BAM file")), ToolInput(tag="in_input_vcf", input_type=File(optional=True), prefix="--inputVCF", doc=InputDocumentation(doc="optional input VCF file;")), ToolInput(tag="in_calculated", input_type=String(), position=0, doc=InputDocumentation(doc="--isRna               RNAseq varinat calling only; default is DNAseq"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Smcounter2_V0_1_0().translate("wdl", allow_empty_container=True)

